Rice.require 'Native'

-----------------------------------------------------------------------------
-- Local Function :
-----------------------------------------------------------------------------
local function isEmpty( value )
	return ( not value or '' == value )
end

local ansiCodePage	= Native.Dll('kernel32.dll'):api('GetACP'):call_int()
local function isLeadByte( bytecode )
	local kernel32			= Native.Dll('kernel32.dll')

	return (kernel32:api('IsDBCSLeadByteEx')
	:with_int( ansiCodePage )
	:with_byte( bytecode )
	:call_int() ~= 0 )
end

local function GetTrimmedString( str, max_length )
	if (not str) or (not max_length) then
		return ''
	end

	local buf_size = math.min( string.len(str), max_length )

	local index = 1
	while index <= buf_size do
		if isLeadByte( string.byte( str, index ) ) then
			if index == buf_size then
				buf_size = buf_size - 1
				do break end
			end
			index = index + 2
		else
			if index == buf_size  then
				do break end
			end
			index = index + 1
		end
	end

	return string.sub( str, 1, buf_size )
end

local function GetJob_Name( tbl )
	if( isEmpty(tbl.jobname) ) then
		return '""'
	else
		return '"' .. GetTrimmedString( tbl.jobname, 80 ) .. '"'
	end
end

-----------------------------------------------------------------------------
-- Export Function : Generate Command
-----------------------------------------------------------------------------
function generate_command(settings_table)
  local commands = {}

  table.insert( commands, string.char(0x1b) .. '%-12345X')

  table.insert( commands, '@PJL EOJ NAME = ' .. GetJob_Name( settings_table ) .. '\r\n' )

  table.insert( commands, string.char(0x1b) .. '%-12345X')

  return table.concat(commands)
end

return true
