
function table:cat(other)

  if(type(self) ~= 'table') then
    error("bad argument #1 to 'cat' (table expected, got " .. type(self) .. ")", 2)
  end
  
  if(type(other) ~= 'table') then
    return self
  end

  local index = nil
  local value = nil

  while(true) do
    index, value =  next(other, index)
    if(not index) then break end

    if(type(index) == 'number') then
      table.insert(self, value)
    elseif(type(value) == 'table' and self[index] and type(self[index]) == 'table' ) then
      table.cat(self[index], value)
    else
      self[index] = value
    end
  end

  return self
end

return true
